# -*- coding: utf-8 -*-
#
#
# $Id: bytemsg.py,v 1.9 2004/08/03 07:42:25 hd Exp $

"""Open Unified Storage System Protocol

Stability: None

@author: U{HD<mailto:hdcola@gmail.com>}

@see: Open Unified Storage System Protocol淶
"""
import struct

class ByteMessage:
    """Ϣ"""
    
    def __init__(self):
        """ʼһϢ"""
        # Ϣͷ
        # self.head = None
        # Ϣ
        # self.body = None
        # Ϣ
        # self.msgutilcls = None
        # ǰϢ
        # self.msgname = ''
        # ǰЭ
        # self.protocolname = ''

    def loadMessage(self, packet):
        """ӶмسϢ"""
        # ذͷ
        self.head.loadHead(packet[:len(self.head)])
        self.msgname = self.msgutilcls.commandinfo[self.head.id]
        # ϢIDذ
        self.body.loadBody(self.msgname, packet[len(self.head):])

    def setMsgName(self, msgname):
        """Ϣ"""
        self.head.setId(self.msgutilcls.nametoid[msgname])
        self.msgname = msgname

    def packed(self):
        """ϢΪPDU"""
        body = self.body.packed()
        if (body == None):
            return self.head.packed()
        else:
            self.head.setLength(len(self.head) + len(body))
            return self.head.packed() + body

    def __str__(self):
        """ַ"""
        return str(self.head) + '\n' + str(self.body)

class ByteMessageHead:
    """ϢϢͷ"""
    def __init__(self, parent):
        # 
        self.length = 12
        # ID
        self.id = 0
        # к
        self.sequence = 0
        # 
        self.parent = parent

    def __len__(self):
        """ͷ12"""
        return 12

    def setId(self,id):
        """ID"""
        self.id = id

    def setSequence(self,sequence):
        """÷"""
        self.sequence = sequence

    def setLength(self, length):
        """"""
        self.length = length

    def loadHead(self, header):
        """תһPDU (protocol data unit)һϢͷ
        ϢͷĸʽΪlength(4ֽ)commandid4ֽڣsequence4ֽڣ12ֽڳ
        """
        self.length,self.id,self.sequence = struct.unpack('>III', header)
    
    def packed(self):
        """תһϢͷΪ
        ϢͷĸʽΪlength(4ֽ)commandid4ֽڣsequence4ֽڣ12ֽڳ
        """
        return struct.pack('>III', self.length, self.id, self.sequence)

    def __str__(self):
        """ַ"""
        plist = []
        plist.append("ϢID:%s" % self.id)
        plist.append("Ϣȣ%s" % self.length)
        plist.append("Ϣкţ%s" % self.sequence)
        return reduce(lambda x,y: x + "\n" + y, plist)

class ByteMessageBody:
    """ƱĵϢ"""
    def __init__(self, parent):
        # Ϣ
        self.fields = {}
        self.setField = self.fields.__setitem__
        # 
        self.parent = parent

    def loadBody(self, msgname, packet):
        """תһΪϢ"""
        # ҵķ
        method = getattr(self.parent , "unpack_%s_%s" %(self.parent.protocolname, msgname), None)
        method(packet)
        self.conversionString()
    
    def packed(self):
        """תϢΪ"""
        # ҵ
        method = getattr(self.parent , "pack_%s_%s" %(self.parent.protocolname, self.parent.msgname), None)
        return method(self.fields)

    def conversionString(self):
        """ȥfiledsַе\x00"""
        for field in self.fields.keys():
            if ( isinstance(self.fields[field],str) ):
                index = self.fields[field].find('\0')
                if index > -1:
                    self.fields[field] = self.fields[field][:index]

    def __str__(self):
        """ַ"""
        if len(self.fields) > 0:
            plist = []
            for field in self.fields.keys():
                plist.append(str(field) + ""  + str(self.fields[field]))
            return reduce(lambda x,y: x + "\n" + y, plist)
        else:
            return ""

class ByteMessageUtil:
    """Ϣ"""
    def __init__(self):
        """ʼ"""
        self.commandinfo = {}
        self.nametoid = {}

    def getCommandinfo(self):
        """ȡϢ"""
        return self.commandinfo

    def getCommandName(self, commandid):
        return self.commandinfo[commandid]