# -*- coding: utf-8 -*-
#
#
# $Id: ussd.py,v 1.5 2004/08/02 09:31:47 hd Exp $
"""ʵUSSDaemon
"""

from uss.message import usspmsg
from uss.protocols import ussp
from twisted.internet import reactor, protocol
from time import clock

class USSServerProtocol(ussp.USSProtocol):
    """һUSSЭ鴦"""
    def connectionMade(self):
        """ˣʲô"""
        pass

    def on_ussp_connect(self, message):
        """ͻconnect"""
        smessage = usspmsg.USSPMessage()
        smessage.head.sequence = message.head.sequence
        smessage.setMsgName('connect_resp')
        smessage.body.setField('status',1)
        smessage.body.setField('version',1)
        self.sendData(smessage.packed())

    def on_ussp_mail_counter(self, message):
        """ͻmail_counter"""
        smessage = usspmsg.USSPMessage()
        smessage.head.sequence = message.head.sequence
        smessage.setMsgName('mail_counter_resp')
        smessage.body.setField('uid',message.body.fields['uid'])
        smessage.body.setField('number',2028)
        self.sendData(smessage.packed())

    def on_ussp_terminate(self, message):
        """ͻterminate"""
        smessage = usspmsg.USSPMessage()
        smessage.head.sequence = message.head.sequence
        smessage.setMsgName('terminate_resp')
        self.sendData(smessage.packed())
        # ˣϿѾ
        self.transport.loseConnection()

class USSServerFactory(protocol.ServerFactory):
    """USS"""
    protocol = USSServerProtocol

def main():
    f = USSServerFactory()
    reactor.listenTCP(7890, f)
    reactor.run()

if __name__ == "__main__":
    main()